# Get Started - iOS

## Quick Start

TapTalk.io helps you to implement real-time chat with any type of your client app with speed and efficiency. Our iOS SDK provides you with various methods to initialize, configure, and build the chat from the client-side - no server-side implementation is required because our reliable infra management service is delivered with the SDK. This page presents a brief overview of the SDK’s structure and abilities, then lets you go through the preliminary steps of implementing the SDK in your own app.

## Configure and Initialize TapTalk.io iOS SDK

#### **Step 1: Create a new application from your dashboard**

**1.** Login to [TapTalk.io Dashboard](https://taptalk.io/), then choose **Development** -> **Apps**

![](/files/-MHKvQJYwokZj2SvRd6U)

**2**. Click **New App** Button, input **App Name** and choose **Platform**, and then click **Create New App** Button.

![](/files/-MHKxC_cD1-kv3lPxiSk)

![](/files/-MHKxGJV7RBtqLBu8UwT)

**3.** A pop-up dialog will be shown with provided **App Key ID** & **App Key Secret**

![](/files/-MHKxQLyhxLOunGM05hx)

{% hint style="warning" %}
**Note:** Please remember to save your **App Key ID** & your **App Key Secret** because it will only be shown once and will be used in [TapTalk.io initialization](/powertalk-chat-sdk-documentation/powertalk-ios/get-started.md#step-5-initialize-taptalk-io-in-your-application-class)
{% endhint %}

#### Step 2: Install PowerTalk iOS SDK **with CocoaPods**

You can install the TapTalk.io Omnichannel iOS SDK using [CocoaPods](https://cocoapods.org/) like the following. If you are new to CocoaPods, you can see more information in [Cocoapods guides](https://guides.cocoapods.org/using/getting-started.html). First, navigate to the *ios* folder of your React Native project directory, and check if a file named **Podfile** exists. If there is no **Podfile** in the *ios* folder, we will create a new one using terminal. Open a terminal window and navigate to the *ios* directory of your React Native project, then create a **Podfile** by running the following command in the terminal:

```bash
$ pod init
```

Then **Podfile** will be created in your project directory. Open the **Podfile** and add the following lines to the **Podfile**.

{% tabs %}
{% tab title="Podfile" %}

```ruby
# Please make sure you define platform on your Podfile
# Make sure to use ios 11.0 for minimum deployment target

platform :ios, '11.0'
use_modular_headers!

target "YourProjectName" do
    pod 'TapTalk'
end
```

{% endtab %}
{% endtabs %}

{% hint style="warning" %} <mark style="color:red;">**Note**</mark><mark style="color:red;">:</mark> <mark style="color:red;"></mark><mark style="color:red;">**For SDK version 1.4.1 and above,**</mark><mark style="color:red;">**&#x20;**</mark><mark style="color:red;">**`use_frameworks!`**</mark><mark style="color:red;">**&#x20;**</mark><mark style="color:red;">**is replaced with**</mark><mark style="color:red;">**&#x20;**</mark><mark style="color:red;">**`use_modular_headers!`**</mark><mark style="color:red;">**&#x20;**</mark><mark style="color:red;">**to handle some compatibility issues.**</mark>

For versions below 1.4.1, please replace **`use_modular_headers!`** on the code above with **`use_frameworks!`**
{% endhint %}

{% hint style="warning" %}
**Note:** Please make sure you implement ios version 11.0`platform :ios, '11.0'` for minimum deployment target to obtain latest update of TapTalk.io SDK
{% endhint %}

{% hint style="warning" %}
**Note:** If you are using SDK version lower than 1.4.1 and your **podfile** has Flipper enabled, disable it by commenting the following lines to enable `use_frameworks!`.
{% endhint %}

```
#use_flipper!
#post_install do |installer|
#  flipper_post_install(installer)
#end
```

Since TapTalk.io use uses **`git-lfs`** (Git Large Files Storage) you will need to install **GIT LFS** to clone/install TapTalk.io SDK through **Cocoapods**.

{% hint style="warning" %}
**Note**: Make sure to install **`git-lfs`**&#x62;efore pod install, otherwise the pod install / pod update will be error&#x20;
{% endhint %}

Easiest way to install [git-lfs](https://git-lfs.github.com) is using [brew](https://brew.sh):

{% tabs %}
{% tab title="Terminal" %}

```bash
brew install git-lfs
git lfs install
```

{% endtab %}
{% endtabs %}

Next, after the **`git-lfs`** is installed, install the TapTalk.io through CocoaPods.

{% tabs %}
{% tab title="Terminal" %}

```bash
$ pod install
```

{% endtab %}
{% endtabs %}

#### Step 3: Open React Native project's ios workspace in Xcode

After the pod has finished installing, navigate to the *ios* folder inside your React Native project root folder and locate a file named **YourProjectName.xcworkspace**, then open this file with Xcode. We will follow the next steps by configuring the project from Xcode.

#### Step 4: Grant permission in your application project

To make sure TapTalk.io has all permission to access the user's media, file, location, and contact, the application needs to ask for permission. Go to your **info.plist**, and add the following key-value pairs.

<table data-header-hidden><thead><tr><th width="339">Information Property Key</th><th>Information Property Value</th></tr></thead><tbody><tr><td><strong>Information Property Key</strong></td><td><strong>Information Property Value</strong></td></tr><tr><td>Privacy - Camera Usage Description</td><td>$(PRODUCT_NAME) needs to request access to your camera to take profile picture and to send image chat.</td></tr><tr><td>Privacy - Contacts Usage Description</td><td>$(PRODUCT_NAME) need your permission to access your contact, we will sync your contact to our server and automatically find your friend so it is easier for you to find your friends.</td></tr><tr><td>Privacy - Photo Library Additions Usage Description</td><td>$(PRODUCT_NAME) needs to request access to your photo library to save photo.</td></tr><tr><td>Privacy - Photo Library Usage Description</td><td>$(PRODUCT_NAME) needs to request access to your photo library to take profile picture and to send image chat.</td></tr><tr><td>Privacy - Location When In Use Usage Description</td><td>$(PRODUCT_NAME) needs to request access to your location to send location chat.</td></tr></tbody></table>

{% hint style="info" %}
**Note:** You can change **Information Property Value** based on your own words and will be appears when the application needs the permission.
{% endhint %}

![](/files/-MHLISj3JHnpzjIeKv5r)

#### Step 5: Enable background modes

Background modes is required to handle background process in TapTalk.io. It is used to run some processes in the background before the app is killed. For more information about the processes, check out the [background process section](/powertalk-chat-sdk-documentation/powertalk-ios/background-process-in-taptalk.io.md).\
To enable **background modes**, go to **Target** -> **Capabilities**, then turn **Background Modes** toggle to **ON**, next select **Background fetch** and **Remote notifications**

![](/files/-MHLIm1-VkzIwjxQilqS)

After you turn on the **Background Modes**, **Required background modes** key will be added automatically in your **Info.plist** as shown below.

![](/files/-MHLItjSE_HAsYniTXmS)

#### Step 6: Initialize Taptalk.io in your Application class

In order to use TapTalk.io, you must first initialize a TapTalk.io instance by passing the `APP_KEY_ID`, `APP_KEY_SECRET`, `APP_BASE_URL`, and `IMPLEMENTATION_TYPE` assigned to your application to the `initWithAppKeyID:appKeySecret:apiURLString:implementationType:` method as a parameter. Generally, initialization is implemented in the **appDelegate** `application:didFinishLaunchingWithOptions:` method.

{% hint style="warning" %}
**Note:** To get **BASE\_URL** you can follow our documentation on [how to get Base URL](/powertalk-chat-sdk-documentation/powertalk-server-api/base-url.md) on TapTalk.io.
{% endhint %}

{% tabs %}
{% tab title="Objective-C" %}
{% code title="AppDelegate.m" %}

```csharp
// Import TapTalk.io
#import <TapTalk/TapTalk.h>

@implementation AppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
 
  // Initialize TapTalk.io
  [[TapTalk sharedInstance] initWithAppKeyID:APP_KEY_ID 
                                appKeySecret:APP_KEY_SECRET 
                                apiURLString:APP_BASE_URL 
                          implementationType:IMPLEMENTATION_TYPE];
}

...

@end
```

{% endcode %}
{% endtab %}
{% endtabs %}

{% hint style="info" %}
**Parameters**\
**APP\_KEY\_ID**: (String) application key ID\
**APP\_KEY\_SECRET**: (String) application key Secret\
**APP\_BASE\_URL**: (String) base API URL\
**IMPLEMENTATION\_TYPE**: (enum) found in TapTalkImplentationType, more detailed information below
{% endhint %}

{% hint style="info" %}
**IMPLEMENTATION\_TYPE**\
TapTalkImplementationType consists of 3 types which are:\
\&#xNAN;**`TapTalkImplementationTypeUI`**: used for implementation with only TapUI\
\&#xNAN;**`TapTalkImplementationTypeCore`**: used for implementation with only TapCore\
\&#xNAN;**`TapTalkImplementationTypeCombine`**: used for implementation with both of TapCore and TapUI combined
{% endhint %}

{% hint style="info" %}
**Note**: In the [Event Delegate](/powertalk-chat-sdk-documentation/powertalk-ios/event-delegate.md) page, you can find detailed information on the usages of TapTalk iOS SDK's delegates and callbacks.
{% endhint %}

You may also call `initWithAppKeyID:appKeySecret:apiURLString:implementationType:success:` to obtain callback once the initialization is finished.

{% tabs %}
{% tab title="Objective-C" %}
{% code title="AppDelegate.m" %}

```csharp
// Import TapTalk.io
#import <TapTalk/TapTalk.h>

@implementation AppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
 
  //Initialize TapTalk.io
  [[TapTalk sharedInstance] initWithAppKeyID:APP_KEY_ID 
                                appKeySecret:APP_KEY_SECRET 
                                apiURLString:APP_BASE_URL 
                          implementationType:IMPLEMENTATION_TYPE
                                     success:^{
        // Initialization finished
  }];
}

...

@end
```

{% endcode %}
{% endtab %}
{% endtabs %}

#### Step 7: Implement application delegate

To allow the iOS SDK to respond to the connection and state changes in your iOS client app, you have to implement all of our application delegate methods in your UIApplicationDelegate methods in appDelegate file. You can follow the instructions in [Implement Application Delegate page](/powertalk-chat-sdk-documentation/powertalk-ios/implement-application-delegate.md).

#### Step 8: Authenticate to TapTalk.io

In order to use the abilities of the iOS SDK in your client app, a TapTalk instance must be initiated in each client app through user authentication with TapTalk.io server. An authenticated user account allows the instance to communicate and interact with the server. To authenticate your user with the server, follow the instructions in [Authentication page](/powertalk-chat-sdk-documentation/powertalk-ios/authentication.md).

### Initialize Google Places API Key (Optional)

To enable location search result preview while sending location message, a Google Places API Key is required. To obtain the API key for your application, you can check [the documentation](https://developers.google.com/places/web-service/get-api-key) provided by Google. To initialize, insert your obtained key using the `initializeGooglePlacesApiKey()` method.

{% tabs %}
{% tab title="Objective-C" %}

```csharp
#import <TapTalk/TapTalk.h>
  
- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
  
    //Initialize Google Places API Key
    [[TapTalk sharedInstance] initializeGooglePlacesAPIKey:GOOGLE_PLACES_API_KEY]; 
}
```

{% endtab %}
{% endtabs %}

{% hint style="info" %}
**Parameters**\
**GOOGLE\_PLACES\_API\_KEY**: (String) Google Places API Key
{% endhint %}

## Bridge to React Native

#### **Step 1: Create a method in AppDelegate to navigate to PowerTalk Chat View**

After the configurations above are completed, we will add a method named `navigateToPowerTalk` in the project's AppDelegate to navigate to PowerTalk chat view. Open your **AppDelegate.m** file and add the following:

{% code title="AppDelegate.m" %}

```csharp
@interface AppDelegate () <TapTalkLiveDelegate>

// Add a UINavigationController variable
@property (strong, nonatomic) UINavigationController *navigationController;

@end

@implementation AppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{

  [[TapTalkLive sharedInstance] application:application didFinishLaunchingWithOptions:launchOptions];
  
  RCTBridge *bridge = [[RCTBridge alloc] initWithDelegate:self launchOptions:launchOptions];
  RCTRootView *rootView = [[RCTRootView alloc] initWithBridge:bridge
                                                   moduleName:@"PowerTalkReactNative"
                                            initialProperties:nil];

  rootView.backgroundColor = [[UIColor alloc] initWithRed:1.0f green:1.0f blue:1.0f alpha:1];
  
  _window = [[UIWindow alloc] initWithFrame:CGRectMake(0.0f, 0.0f, CGRectGetWidth([UIScreen mainScreen].bounds), CGRectGetHeight([UIScreen mainScreen].bounds))];
  
  // Initialize navigation controller
  UIViewController *rootViewController = [[UIViewController alloc] init];
  rootViewController.view = rootView;
  _navigationController = [[UINavigationController alloc] initWithRootViewController:rootViewController];
  [self.navigationController setNavigationBarHidden:YES animated:YES];
  self.window.rootViewController = self.navigationController;
  [self.window makeKeyAndVisible];
  
  [[TapTalk sharedInstance] initWithAppKeyID: ... ];
  
  NSSetUncaughtExceptionHandler(&handleExceptions);
  
  return YES;
}

...

// Method to open chat view
- (void)navigateToPowerTalk {
    //Initialize TapTalk.io room list view controller here
    TAPRoomListViewController *roomListViewController = [[TapUI sharedInstance] roomListViewController]; 
    UINavigationController *roomListNavigationController = [[UINavigationController alloc] initWithRootViewController:roomListViewController];
  
    //Present room list view
    [self presentViewController:roomListViewController animated:YES completion:^{
        //completion
    }];
}

@end
```

{% endcode %}

Then open your **AppDelegate.h** file and add the following lines to enable the previously created method to be called from another file.

{% code title="AppDelegate.h" %}

```csharp
@interface AppDelegate : UIResponder <UIApplicationDelegate, RCTBridgeDelegate>

- (void)navigateToPowerTalk;

...

@end
```

{% endcode %}

#### **Step 2: Create module file in the project folder**

We will name this file *PowerTalkStarterModule*. Select *NSObject* as the subclass and *Objective-C* as the language, then press *Next*, and press *Create* on the next window.

Two files named *PowerTalkStarterModule.h* and *PowerTalkStarterModule.m* will be generated in your project folder. First, open *PowerTalkStarterModule.h* and update its contents with the following:

{% code title="PowerTalkStarterModule.h" %}

```csharp
#import <React/RCTBridgeModule.h>

NS_ASSUME_NONNULL_BEGIN

@interface PowerTalkStarterModule : NSObject <RCTBridgeModule>

@end

NS_ASSUME_NONNULL_END
```

{% endcode %}

Then open the *PowerTalkStarterModule.m* file and modify it like below:

{% code title="PowerTalkStarterModule.m" %}

```csharp
#import "PowerTalkStarterModule.h"
#import "AppDelegate.h"

@implementation PowerTalkStarterModule

RCT_EXPORT_MODULE(PowerTalkStarter);

RCT_EXPORT_METHOD(navigateToPowerTalk)
{
  dispatch_async(dispatch_get_main_queue(), ^{
    AppDelegate *appDelegate = (AppDelegate *) [UIApplication sharedApplication].delegate;
    [appDelegate navigateToPowerTalk];
  });
}

RCT_EXPORT_METHOD(getActivityName:(RCTResponseSenderBlock) callback)
{
  callback(@[@"PowerTalkStarter (callback)"]);
}

@end
```

{% endcode %}

{% hint style="info" %}
**RCT\_EXPORT\_MODULE** exposes this module to react via a compile time macro.

**RCT\_EXPORT\_METHOD** will enable the method to be invoked from javascript of a React Native app.
{% endhint %}

#### Step 3. Open PowerTalk Chat View

Once the module set up is done, you can find a place in your application where you would like to add a call to the native module’s `navigateToPowerTalk()` method to open PowerTalk chat view.&#x20;

&#x20;In order to access your native module from JavaScript you need to first import `NativeModules` from React Native:

```javascript
import { NativeModules } from 'react-native';
```

You can then invoke the native method `navigateToPowerTalk()` to open PowerTalk chat view. Here we will be using a button's  `onPress()` method as an example.

```javascript
<Button
    onPress={() => NativeModules.PowerTalkStarter.navigateToPowerTalk()}
    title='Launch PowerTalk'
/>
```

{% hint style="info" %}
**Note**: You can check a more complete implementation guide in the [PowerTalk iOS](/powertalk-chat-sdk-documentation/powertalk-ios.md) section.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.taptalk.io/powertalk-chat-sdk-documentation/powertalk-react-native/get-started-ios.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
